mcast6-queryfld04 6.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199
  1. #!/bin/sh
  2. ################################################################################
  3. ## ##
  4. ## Copyright (c) International Business Machines Corp., 2006 ##
  5. ## ##
  6. ## This program is free software; you can redistribute it and#or modify ##
  7. ## it under the terms of the GNU General Public License as published by ##
  8. ## the Free Software Foundation; either version 2 of the License, or ##
  9. ## (at your option) any later version. ##
  10. ## ##
  11. ## This program is distributed in the hope that it will be useful, but ##
  12. ## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
  13. ## or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License ##
  14. ## for more details. ##
  15. ## ##
  16. ## You should have received a copy of the GNU General Public License ##
  17. ## along with this program; if not, write to the Free Software ##
  18. ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA ##
  19. ## ##
  20. ## ##
  21. ################################################################################
  22. #
  23. # File:
  24. # mcast6-queryfld04
  25. #
  26. # Description:
  27. # Verify that the kernel is not crashed when joining plural IPv6 multicast
  28. # groups on separate socket, then receiving a large number of General Query
  29. #
  30. # Setup:
  31. # See testcases/network/stress/README
  32. #
  33. # Author:
  34. # Mitsuru Chinen <mitch@jp.ibm.com>
  35. #
  36. # History:
  37. # May 7 2006 - Created (Mitsuru Chinen)
  38. #
  39. #-----------------------------------------------------------------------
  40. # Uncomment line below for debug output.
  41. #trace_logic=${trace_logic:-"set -x"}
  42. $trace_logic
  43. # The test case ID, the test case count and the total number of test case
  44. TCID=mcast6-queryfld04
  45. TST_TOTAL=1
  46. TST_COUNT=1
  47. export TCID
  48. export TST_COUNT
  49. export TST_TOTAL
  50. # Make sure the value of LTPROOT
  51. LTPROOT=${LTPROOT:-`(cd ../../../../.. ; pwd)`}
  52. export LTPROOT
  53. # Check the environmanet variable
  54. . check_envval || exit $TST_TOTAL
  55. # Dulation of the test [sec]
  56. NS_DURATION=${NS_DURATION:-3600} # 1 hour
  57. # Number of the multicast to join
  58. MCASTNUM_NORMAL=${MCASTNUM_NORMAL:-20}
  59. # The number of the test link where tests run
  60. LINK_NUM=${LINK_NUM:-0}
  61. # Network portion of the IPv6 address
  62. NETWORK_PART="fec0:1:1:1"
  63. # Host portion of the IPv6 address
  64. LHOST_HOST_PART=":2" # local host
  65. RHOST_HOST_PART=":1" # remote host
  66. # Prefix of the Multicast Address
  67. MCAST_ADDR_PREFIX=ff0e:
  68. #-----------------------------------------------------------------------
  69. #
  70. # Function: do_cleanup
  71. #
  72. # Description:
  73. # Recover the system configuration
  74. #
  75. #-----------------------------------------------------------------------
  76. do_cleanup()
  77. {
  78. # Make sure to kill the multicast receiver and sender
  79. killall -SIGHUP ns-mcast_join >/dev/null 2>&1
  80. $LTP_RSH $RHOST killall -SIGHUP ns-icmpv6_sender >/dev/null 2>&1
  81. # Clean up each interface
  82. initialize_if lhost ${LINK_NUM}
  83. initialize_if rhost ${LINK_NUM}
  84. }
  85. #-----------------------------------------------------------------------
  86. #
  87. # Function: do_setup
  88. #
  89. # Description:
  90. # Configure the ssystem for the test
  91. #
  92. #-----------------------------------------------------------------------
  93. do_setup()
  94. {
  95. # Initialize the system configuration
  96. do_cleanup
  97. # Call do_cleanup function before exit
  98. trap do_cleanup 0
  99. # name of interface of the local/remote host
  100. lhost_ifname=`get_ifname lhost $LINK_NUM`
  101. if [ $? -ne 0 ]; then
  102. tst_resm TBROK "Failed to get the interface name at the local host"
  103. exit $TST_TOTAL
  104. fi
  105. rhost_ifname=`get_ifname rhost $LINK_NUM`
  106. if [ $? -ne 0 ]; then
  107. tst_resm TBROK "Failed to get the interface name at the remote host"
  108. exit $TST_TOTAL
  109. fi
  110. # Set IPv6 addresses to the interfaces
  111. add_ipv6addr lhost $LINK_NUM $NETWORK_PART $LHOST_HOST_PART
  112. if [ $? -ne 0 ]; then
  113. tst_resm TBROK "Failed to add any IP address at the local host"
  114. exit 1
  115. fi
  116. add_ipv6addr rhost $LINK_NUM $NETWORK_PART $RHOST_HOST_PART
  117. if [ $? -ne 0 ]; then
  118. tst_resm TBROK "Failed to add any IP address at the remote host"
  119. exit 1
  120. fi
  121. # IPv6 address of the local/remote host
  122. lhost_addr="${NETWORK_PART}:${LHOST_HOST_PART}"
  123. rhost_addr="${NETWORK_PART}:${RHOST_HOST_PART}"
  124. rhost_linklocal="fe80:${RHOST_HOST_PART}"
  125. # Make sure the connectvity
  126. check_icmpv6_connectivity $lhost_ifname $rhost_addr
  127. if [ $? -ne 0 ]; then
  128. tst_resm TBROK "There is no IPv6 connectivity."
  129. exit 1
  130. fi
  131. # Make sure the sysctl values
  132. sysctl -w net.ipv6.conf.all.force_mld_version=0 >/dev/null
  133. if [ $? -ne 0 ]; then
  134. tst_resm TBROK "Failed to set the sysctl value regarding multicast"
  135. exit $TST_TOTAL
  136. fi
  137. sysctl -w net.ipv6.conf.${lhost_ifname}.force_mld_version=0 >/dev/null
  138. sysctl -w net.ipv6.mld_max_msf=10 >/dev/null
  139. }
  140. #-----------------------------------------------------------------------
  141. #
  142. # Main
  143. #
  144. #
  145. # Test description
  146. tst_resm TINFO "Verify that the kernel is not crashed when joining $MCASTNUM_NORMAL IPv6 multicast groups on separate sockets, then receiving a large number of General Query in $NS_DURATION [sec]"
  147. do_setup
  148. # Run a multicast join tool
  149. ns-mcast_join -f 6 -I $lhost_ifname -n $MCASTNUM_NORMAL -p $MCAST_ADDR_PREFIX >/dev/null
  150. if [ $? -ne 0 ]; then
  151. tst_resm TBROK "Failed to start multicast joining tool Please check the environment"
  152. exit 1
  153. fi
  154. # Send MLD General Query from the remote host
  155. ret=`$LTP_RSH $RHOST ${LTPROOT}/testcases/bin/ns-icmpv6_sender -I $rhost_ifname -S $rhost_linklocal -m -r 0 -t $NS_DURATION' ; echo $?'`
  156. if [ $ret -ne 0 ]; then
  157. tst_resm TBROK "Failed to start MLD querier"
  158. exit 1
  159. fi
  160. #-----------------------------------------------------------------------
  161. #
  162. # Clean up
  163. #
  164. killall -SIGHUP ns-mcast_join >/dev/null 2>&1
  165. tst_resm TPASS "Test is finished successfully."
  166. exit 0